﻿/*
The author of this Script is Hidetoshi Iizawa.
(C) Copyright Me. All Rights Reserved.
@@@BUILDINFO@@@ BG_CacheRender_ver1.02.jsx !Version! Tue Jul 10 2012 13:22:47 GMT+0900
ver 1.00 12/6/9: 公開しました。
ver 1.01 12/6/13: フォルダ選択状態だとコマンドメニューが実行できないので、選択をクリアしました。
ver 1.02 12/7/10: functionの位置を変更。
*/

(function(){
	var AEVersion=parseFloat(app.version);
	if(AEVersion>=11){
		app.beginUndoGroup("BGキャッシュ作成");
		//----------------------------------------------------------------------------
		var rbd = new radioBtnDialog;
		rbd.btnIndex = 2;
		if(rbd.execute()==true){
			//プロジェクトの選択をクリアする
			var selItem = app.project.selection;
			for(var i=0;i<selItem.length;i++){
				selItem[i].selected = false;
			}
			var pNum = app.project.numItems;
			for(var i=1;i<=pNum;i++){	
				if(app.project.item(i) instanceof CompItem){
					var tComp = app.project.item(i);
					tComp.resolutionFactor = [rbd.btnIndex,rbd.btnIndex];
					tComp.selected = true;
				}
			}
			//"ワークエリアをバックグラウンドでキャッシュ"
			app.executeCommand(3975);
			for(var i=1;i<=pNum;i++){		
				if(app.project.item(i) instanceof CompItem){
					var tComp = app.project.item(i);
					tComp.selected = false;
				}
			}
		}			
		app.endUndoGroup();
	}
	//bry-ful様のHPより
	//http://bry-ful.ddo.jp/BRY/software/AE_Script/help/recipe/index.html
	function radioBtnDialog()
	{
	  this.title = "BGキャッシュ作成"
	  this.caption1 ="フル画質";
	  this.caption2 ="1/2画質";
	  this.caption3 ="1/3画質";
	  this.caption4 ="1/4画質";
	  this.btnIndex =2;
	  this.dialog;

	  //------------------------------------------------------------
	  this.clickRB = function ()
	  {
		this.parent.btnIndex = this.id;
	  }
	  //------------------------------------------------------------
	  this.buildAndShowDialog = function ()
	  { 
		// build the dialog
		var x01 = 20;
		var x02 = x01+180;
		
		var xx01 =50;
		var xx02 =xx01+60;
		var xx03 =xx02+5;
		var xx04 =xx03+60;

		var y01 = 10;
		var y02 = y01+20;
		var y03 = y02+5;
		var y04 = y03+20;
		var y05 = y04+5;
		var y06 = y05+20;
		var y07 = y06+5;
		var y08 = y07+20;
		
		var dlg_w = x02+x01;
		var dlg_h = y08+y01+45;
		var dlg_l = 100;
		var dlg_t = 100;
		
		this.dialog = new Window("dialog",this.title);
		this.dialog.bounds = [dlg_l,dlg_t,dlg_l+dlg_w,dlg_t+dlg_h];
		this.dialog.btnIndex=this.btnIndex;
		this.dialog.center();
		

		var rb1   = this.dialog.add("radiobutton", [ x01, y01, x02, y02],this.caption1);
		rb1.id=1;
		rb1.onClick = this.clickRB;
		var rb2 = this.dialog.add("radiobutton"  , [ x01, y03, x02, y04],this.caption2);
		rb2.id=2;
		rb2.onClick = this.clickRB;
		var rb3 = this.dialog.add("radiobutton"  , [ x01, y05, x02, y06],this.caption3);
		rb3.id=3;
		rb3.onClick = this.clickRB;
		var rb4 = this.dialog.add("radiobutton"  , [ x01, y05+25, x02, y06+25],this.caption4);
		rb4.id=4;
		rb4.onClick = this.clickRB;
		
		switch(this.btnIndex){
		  case 1:rb1.value =true; break;
		  case 2:rb2.value =true; break;
		  case 3:rb3.value =true; break;
		  case 4:rb4.value =true; break;
		}

		var okBtn     = this.dialog.add("button", [ xx01+25, y07+40, xx02+25, y08+40], "OK",     {name:'ok'} );
		var cancelBtn = this.dialog.add("button", [ xx03+25, y07+40, xx04+25, y08+40], "Cancel", {name:'cancel'});
		
		return this.dialog.show();
	  }
	  this.execute =function()
	  {
		while(true){
		  var r=this.buildAndShowDialog();
		  if (r==1){
			this.btnIndex=this.dialog.btnIndex;
			return true;
		  }else{
			return false;
		  }
	  }
		return true;
	  }
	  //**************************************************************************
	}// end of radioBtnDialog
})();

